#!/usr/bin/perl
# indexsoft configurator
# http://www.indexsoft.com

#############################################################################
#
#  You are developer of web based applications writen in perl? If yes that indexsoft
#  configurator is exactly you are looking for. Of course you know that the greater part 
#  of perl applications require configuration variables. In most cases you (or your
#  customers) need to edit configuration file (or script itself) and define all required
#  variables. Everybody get tired... This is not good and you know it!
#
#  indexsoft configurator is web based script that lets you to create configuration 
#  files for YOUR OWN perl scripts with easy. After configuration file will be created
#  you will include it in your scripts by 'require' perl finction.
#
#  indexsoft configurator not only will create and let modify configuration files. It will
#  also keep them up-to-date when new versions of your scrips will be released and
#  if them will require additional changes in configuration files.
#
#  More over indexsoft configurator is supports skins that let you fully customize
#  it to looks exactly as your applications.


#############################################################################
#  indexsoft configurator must work in anyway even language.pm and config.pm
#  configuration files are corrupted or empty. That is why we define all
#  variables here. Usually you do not need to do this in your own scripts
#  Even you can remove this lines from indexsoft configurator
$USERSSKINSDIR = '';
$SKINSDIR = './skins/default/';
$SKINSEXT = '.html';
$CONFIGFILE = './example/example.pm';
$CONFIGINIT = './example/example.ini';
$QUOTEBY = 'qq';
$JOINMULTIPLEBY = ',';
$SCRIPTURL = $ENV{'SCRIPT_NAME'};
$LANG{'can_not_open'} = qq{can not open file};
$LANG{'cfg_file_selected'} = qq{Configuration files selected:};
$LANG{'load_def_values'} = qq{Load default values};
$LANG{'init_values_load_warning'} = qq{Initial values was loaded. This is normal situation if a first launching of the program. You can rewrite configuration file by filling and sending out form below or edit it in text mode to correct an error.};
$LANG{'cfg_damaged_or_no_file'} = qq{configuration file damaged or no such file};
$LANG{'can_not_write'} = qq{can not write file};
$LANG{'save_cfg_file'} = qq{Save configuration file};
#############################################################################


$|++;
$VER = '1.11';
&ReadParameters();
# load language and redefine if redefined
eval('require "./language.pm"');
foreach my $key(%LANG_DEF) { $LANG{$key} = $LANG_DEF{$key} if $LANG_DEF{$key} }
# load config and redefine if redefined
eval('require "./configme.pm"');
$SKINSDIR = $SKINSDIR_DEF if $SKINSDIR_DEF;
$SKINSDIR = $USERSSKINSDIR_DEF if $USERSSKINSDIR_DEF and -d $USERSSKINSDIR_DEF;
$SKINSEXT = $SKINSEXT_DEF if $SKINSEXT_DEF;
$CONFIGFILE = $CONFIGFILE_DEF if $CONFIGFILE_DEF;
$CONFIGINIT = $CONFIGINIT_DEF if $CONFIGINIT_DEF;
$QUOTEBY = $QUOTEBY_DEF if $QUOTEBY_DEF;
$JOINMULTIPLEBY = $JOINMULTIPLEBY_DEF if $JOINMULTIPLEBY_DEF;
$SCRIPTURL = $SCRIPTURL_DEF if $SCRIPTURL_DEF;
# redefined by CGI params if any
$CONFIGFILE = $P{'icfg_cfgfile'} if $P{'icfg_cfgfile'};
$CONFIGINIT = $P{'icfg_cfginit'} if $P{'icfg_cfginit'};

# begin
print "Expires: Mon, 06 May 1996 04:57:00 GMT\nContent-type: text/html\n\n";

# using templates
use ISkins;
$skin = new ISkins($SKINSDIR);
$skin->{'templatesext'} = $SKINSEXT;
$skin->{'loadinmemory'} = 1;
# init [%key_words%]
$skin->{'SCRIPTURL'} = $SCRIPTURL;
$skin->{'CFGFILE'} = $CONFIGFILE;
$skin->{'CFGINIT'} = $CONFIGINIT;
# load templates
$skin->LoadTemplates() && print $skin->{'error'};

print $skin->Template('header');
print $skin->Template('section', "$LANG{'cfg_file_selected'} <i>$CONFIGFILE</i>; <i>$CONFIGINIT</i>");
print $skin->Template('action', $LANG{'load_def_values'}) if $P{'icfg_act'} eq 'loaddefault';

# save file?
if ($P{'icfg_act'} eq 'savetext')
{
	print $skin->Template('action', $LANG{'save_cfg_file'});
	open(FILE, ">$CONFIGFILE") || print $skin->Template('error', "$LANG{'can_not_write'} $CONFIGFILE : $!");
	binmode('FILE'); print FILE $P{'icfg_filecontent'}; close FILE;
}
elsif ($P{'icfg_act'} eq 'saveconfig')
{
	print $skin->Template('action', $LANG{'save_cfg_file'});
	open(FILE, ">$CONFIGFILE") || print $skin->Template('error', "$LANG{'can_not_write'} $CONFIGFILE : $!");
	binmode('FILE');
	foreach $pname(keys(%P))
	{
		next if $pname =~ '^icfg_';
		#$P{$pname} =~ s/\n/\\n/g;
		$P{$pname} =~ s/\0/$JOINMULTIPLEBY/g;
		# variable, array or hash?
		my $var = '$';
		$var = $P{"icfg_var_$pname"} if $P{"icfg_var_$pname"}; $var =~ s/\0.*$//;
		# redefine $quoteby if need. delete possible multiple values
		my $quoteby = $QUOTEBY;
		$quoteby = $P{"icfg_quote_$pname"} if $P{"icfg_quote_$pname"}; $quoteby =~ s/\0.*$//;
		print FILE "$var$pname = $quoteby\{$P{$pname}\};\n";
	}
	print FILE "\n1;\n";
 close FILE;
 }

# we need to load config file before init file to retrieve values and detect errors
eval('require $CONFIGFILE');
$cfgerror = $@ if $@;
print $skin->Template('error', "$LANG{'cfg_damaged_or_no_file'} : $cfgerror") if $cfgerror;

# read config init file
use IConfig;
$cfg = new IConfig($CONFIGINIT);
$cfg->{'cfgparse'} = 1 if !$cfgerror;
$cfg->{'cfgparse'} = 0 if $P{'icfg_act'} eq 'loaddefault';
$cfg->LoadConfig() && print $skin->Template('error', $cfg->{'error'});

# view modes
if ($P{'icfg_act'} eq 'viewtext' and !$cfg->{'error'})
{
	$filecontent = '';
	open(IN, $CONFIGFILE) || print $skin->Template('error', "$LANG{'can_not_open'} $CONFIGFILE : $!");
	binmode('IN'); grep ($filecontent .= $_, <IN>); close IN;
	$filecontent =~ s'&'&#38;'g;
	$filecontent =~ s'<'&#60;'g;
	$filecontent =~ s'>'&#62;'g;
	print $skin->Template('textmode', $filecontent);
}
elsif (!$cfg->{'error'})
{
	print $skin->Template('attention', $LANG{'init_values_load_warning'}) if $cfgerror;
	foreach $section(sort keys %{$cfg->{'config'}})
	{
		$formcontent .= $skin->Template('ssection', $section);
		foreach $subsection(sort keys %{$cfg->{'config'}->{$section}})
		{
			$formcontent .= $skin->Template('formelement', $cfg->{'config'}{$section}{$subsection}{'desc'}, $subsection, $cfg->{'config'}{$section}{$subsection}{'formelement'});
		}
	}
	print $skin->Template('easymode', $formcontent);
}

print $skin->Template('footer');

##########################################################################################
sub ReadParameters
{
	use CGI;
	$MULTIPARTQUERY = new CGI;
	my @params = $MULTIPARTQUERY->param;
	my ($line);
	foreach $line(@params) { %P -> {"$line"} = join("\0", $MULTIPARTQUERY->param("$line")); $P{"$line"} =~ s/\r//g; }
}

