#!/usr/bin/perl
#!/usr/bin/perl -I/directory/where/preinit.pm/file/is/located
# indexsoft Site-UP
# (c) indexsoft 2001-2004
# http://www.indexsoft.com

require "preinit.pm";
require "$CONFIGFILE";
require "subrouts.pm";
require "initvars.pm";

print qq{Expires: Mon, 06 May 1996 04:57:00 GMT\nContent-type: text/html\nPragma: no-cache\nCache-Control: no-cache\n\n};
if ($skinerror) { print $skinerror; exit; }

print $skin->Template('page_header');
print $skin->Template('page_tips') if $SHOWTIPS;
print $skin->Template('page_section', "$lang{'edit_file'} $P{'file'} $lang{'in_directory'} $CURDIR");

open(IN, "$CURDIR$DIRSEPARATOR$P{'file'}") || print $skin->Template('page_error', "$lang{'can_not_open'} $CURDIR$DIRSEPARATOR$P{'file'}");
binmode('IN'); grep ($filecontent .= $_, <IN>); close IN;

if (grep($P{'file'} =~ /\.$_$/i , split(/\,/, $HTMLFILES))) { $htmleditor = 1; }
$htmleditor = 1 if $P{'editor'} eq 'html';
$htmleditor = 0 if $P{'editor'} eq 'text';

if ($htmleditor)
{
	($filecontent =~ s/^(.*$STARTOFEDITABLECONTENT)//is)?($filecontent_top = $1):($filecontent_top = '');
	($filecontent =~ s/($ENDOFEDITABLECONTENT.*)//is)?($filecontent_bot = $1):($filecontent_bot = '');
	$filecontent_top =~ s'&'&#38;'g; $filecontent_top =~ s'<'&#60;'g; $filecontent_top =~ s'>'&#62;'g;
	$filecontent_bot =~ s'&'&#38;'g; $filecontent_bot =~ s'<'&#60;'g; $filecontent_bot =~ s'>'&#62;'g;
	$filecontent =~ s'&'&#38;'g; $filecontent =~ s'<'&#60;'g; $filecontent =~ s'>'&#62;'g;
	$filecontent = '' if !$filecontent;
	print $skin->Template('edit_htmlarea', 'filecontent', ($MYSTYLESLIST)?(q{['fontstyle'],}):(''), ($MYSTYLESLIST)?(qq{config.fontstyles = [{name:"No class", className:"", classStyle:""},$MYSTYLESLIST];}):(''));
	print $skin->Template('edit_wysiwyg', $P{'file'}, $filecontent_top, $filecontent, $filecontent_bot);
}
else
{
	$filecontent =~ s'&'&#38;'g; $filecontent =~ s'<'&#60;'g; $filecontent =~ s'>'&#62;'g;
	$filecontent = '' if !$filecontent;
	print $skin->Template('edit_textmode', $P{'file'}, $filecontent);
}

print $skin->Template('page_footer');

