#!/usr/bin/perl
#!/usr/bin/perl -I/directory/where/preinit.pm/file/is/located
# indexsoft Site-UP
# (c) indexsoft 2001-2004
# http://www.indexsoft.com

require "preinit.pm";
require "$CONFIGFILE";
require "subrouts.pm";
require "initvars.pm";

print qq{Expires: Mon, 06 May 1996 04:57:00 GMT\nContent-type: text/html\nPragma: no-cache\nCache-Control: no-cache\n\n};
if ($skinerror) { print $skinerror; exit; }

$CURDIR =~ /^(.*)(\\|\/)(.+)$/;
$pagetitle = $3;

$directories .= $skin->Template('menu_goup') if ($DOCUMENT_ROOT ne $CURDIR);

opendir (DIR, $CURDIR);
while ($file = readdir(DIR)) { (-d "$CURDIR$DIRSEPARATOR$file") ? push (@dirs, $file) : push (@files, $file) }
@dirs = sort @dirs; @files = sort @files;
foreach $file(@dirs)
{
	next if grep($file eq $_, split(/\,/, "$IGNOREDIRS"));
	$directories .= $skin->Template('menu_cd', $file) if ($file ne '.' and $file ne '..');
}
foreach $file(@files)
{
	next if grep($file =~ /\.$_$/i , split(/\,/, "$IGNOREFILES"));
	($filedate, $filesize, $fileurl) = &FileInfo("$CURDIR$DIRSEPARATOR$file");
	if (grep($file =~ /\.$_$/i , split(/\,/, "$TEXTFILES,$HTMLFILES"))) { $directories .= $skin->Template('menu_edit', $file, $filesize, $filedate) }
	elsif (grep($file =~ /\.$_$/i , split(/\,/, "$IMGFILES"))) { $directories .= $skin->Template('menu_image', $file, $fileurl, $filesize, $filedate) }
	elsif (grep($file =~ /\.$_$/i , split(/\,/, "$ARCHFILES"))) { $directories .= $skin->Template('menu_archive', $file, $filesize, $filedate) }
	elsif (grep($file =~ /\.$_$/i, split(/\,/, "$XMLFILES"))) { $directories .= $skin->Template('menu_xml', $file, $filesize, $filedate) }
	else { $directories .= $skin->Template('menu_file', $file, $filesize, $filedate) }
}
closedir(DIR);

print $skin->Template('menu_page', $pagetitle, $directories);

